org.osgi.framework.hooks.weaving

## Interface WovenClassListener

    @ConsumerType
    public interface WovenClassListener

Woven Class Listener Service.

Bundles registering this service will receive notifications whenever a `woven class` completes a `state` transition. Woven Class Listeners are not able to modify the woven class in contrast with `weaving hooks`.

Receiving a woven class in the `TRANSFORMED` state allows listeners to observe the modified `byte codes` before the class has been `DEFINED` as well as the additional `dynamic imports` before the `bundle wiring` has been updated.

Woven class listeners are synchronously `called` when a woven class completes a state transition. The woven class processing will not proceed until all woven class listeners are done.

If the Java runtime environment supports permissions, the caller must have `ServicePermission[WovenClassListener,REGISTER]` in order to register a listener.

Since:
  1.1
Author:
  $Id: 4a7a69943bffbc53738f050c51d49f11b67a13cb $

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `modified(WovenClass wovenClass)` Receives notification that a `woven class` has completed a state transition.

### Method Detail

#### modified

    void modified(WovenClass wovenClass)

Receives notification that a `woven class` has completed a state transition.

The listener will be notified when a woven class has entered the `TRANSFORMED`, `DEFINED`, `TRANSFORMING_FAILED` and `DEFINE_FAILED` states.

If this method throws any exception, the Framework must log the exception but otherwise ignore it.

Parameters:
  `wovenClass` - The woven class that completed a state transition.